if(isFile("Config/Client/Functions/Notify.cs"))
{
	exec("Config/Client/Functions/Notify.cs");
}
else
{
	$IRCNotify::Count = 0;
}
$IRCNotify::checkPlayers = 0;
package IRCNotifier
{
	function RTBIC_SC::onJoin(%id,%info,%net)
	{
		parent::onJoin(%id,%info,%net);
		%name = getSubStr(%info,0,strPos(%info,"!"));
		%block = getSubStr(%info,strPos(%info,"!")+1,strPos(%info,"@"));
		%cloak = getSubStr(%info,strPos(%info,"@")+1,strLen(%info));
		if(isNotifyName(%name))
		{
			RTBIC_pushNotification(%name,%name SPC "has joined" SPC %net);
			%Row = IRCNotify_List.findTextIndex(%name TAB "\c3Offline");
			%Row = IRCNotify_List.getRowId(%Row);
			IRCNotify_List.setRowById(%Row,%name TAB "Online");
		}
		
//		RTBIC_SC.onWhoisPartA(%id,scruffy.centralchat.net,"Lilboarder"SPC %name SPC %block SPC %cloak)
	}
	function RTBIC_SC::onQuit(%id,%info,%reas)
	{
		parent::onQuit(%id,%info,%net);
		%name = getSubStr(%info,0,strPos(%info,"!"));
		%block = getSubStr(%info,strPos(%info,"!")+1,strPos(%info,"@"));
		%cloak = getSubStr(%info,strPos(%info,"@")+1,strLen(%info));
		if(isNotifyName(%name))
		{
			RTBIC_pushNotification(%name,%name SPC "has quit. (" @ %reas @")");
			%Row = IRCNotify_List.findTextIndex(%name TAB "Online");
			%Row = IRCNotify_List.getRowId(%Row);
			IRCNotify_List.setRowById(%Row,%name TAB "\c3Offline");
		}
//		RTBIC_SC.onWhoisPartA(%id,scruffy.centralchat.net,"Lilboarder"SPC %name SPC %block SPC %cloak)
	}

//	function RTBIC_SC::onWhoisPartA(%id,%net,%info)
//	{
//		parent::onWhoisPartA(%id,%net,%info);
//		%name = getWord(%info,5);
//		echo(getSubStr(%name,strPos(%name,"-"),strLen(%name)));
//	}
};
activatePackage(IRCNotifier);

RTB_IRCClient.getObject(0).getObject(6).extent = "78 22";
RTB_IRCClient.getObject(0).add(
	new GuiBitmapButtonCtrl() {
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "550 458";
		extent = "53 22";
		minExtent = "8 2";
		visible = "1";
		command = "IRCNotify_open();";
		text = "Add";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button2";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
		wrap = "0";
	}
);

function IRCNotify_Add(%add,%bool,%count)
{
	if(!isNotifyName(%add))
	{
		if(!%bool)
		{
			IRCNotify_List.addRow(%count,%add TAB onlineStatus(%add),%count);
			switch($IRCNotify::Sort)
			{
				case 0:
					IRCNotify_List.sort(0,1);
				case 1:
					IRCNotify_List.sortNumerical(0,1);
				default:
					IRCNotify_List.sort(0,1);
			}
		}
		else
		{
			%num = findFirstBlankNotify();
			IRCNotify_List.addRow(%num,%add TAB onlineStatus(%add),%num);
			IRCNotify_Sort();
			$IRCNotify::Notify[%num] = %add;
			if(%num >= $IRCNotify::Count)
			{
				$IRCNotify::Count++;
			}
			export("$IRCNotify::*","Config/Client/Functions/Notify.cs");
		}
	}
	IRCNotify_Text.setValue("");
}
function IRCNotify_Remove(%rem)
{
	IRCNotify_List.removeRowById(%rem);
	$IRCNotify::Notify[%rem] = "";
	export("$IRCNotify::*","Config/Client/Functions/Notify.cs");
}
function IRCNotify_Sort(%type)
{
	if(%type $= "")
	{
		%type = $IRCNotify::Sort;
	}
	switch(%type)
	{
		case 0:
			IRCNotify_List.sort(0,1);
		case 1:
			IRCNotify_List.sort(1,0);
		default:
			IRCNotify_List.sort(0,1);
	}
	$IRCNotify::Sort = %type;
}
function IRCNotify_pushSession(%id)
{
	%name = IRCNotify_List.getRowTextById(%id);
	%name = getField(%name,0);
	if(isNotifyName(%name) && isNotifyOnline(%name))
	{
		canvas.popDialog(RTB_notify);
		if(RTBIC_hasSession(%name))
		{
			%session = RTBIC_getSession(%name);
			RTBIC_setPane(%session);
			RTBIC_scrollToTab(%name);
		}
		else
		{
			%session = RTBIC_createSession(%name);
			RTBIC_setPane(%session);
			RTBIC_scrollToTab(%name);
		}
	}
}
function IRCNotify_Type(%text)
{
	%pos = IRCNotify_Text.getCursorPos();
	%orig = getSubStr(%text,0,%pos);
	if(%pos == 0)
	{
		IRCNotify_Text.setValue("");
		return;
	}
	if($IRCNotify::Autofill)
	{
		if(checkNotifyPart(%orig) !$= "")
		{
			IRCNotify_Text.setText(checkNotifyPart(%orig));
			IRCNotify_Text.setCursorPos(%pos);
		}
		else
		{
			IRCNotify_Text.setText(%orig);
		}
	}
}
function IRCNotify_Autofill()
{
	%text = IRCNotify_Text.getValue();
	%pos = IRCNotify_Text.getCursorPos();
	%orig = getSubStr(%text,0,%pos);
	if(!$IRCNotify::Autofill)
	{
		IRCNotify_Text.setText(%orig);
	}
	else
	{
		if(checkNotifyPart(%orig) !$= "")
		{
			IRCNotify_Text.setText(checkNotifyPart(%orig));
			IRCNotify_Text.setCursorPos(%pos);
		}
		else
		{
			IRCNotify_Text.setText(%orig);
		}
	}
}
function isNotifyName(%name)
{
	for(%i=0;%i<=$IRCNotify::Count;%i++)
	{
		%list = IRCNotify_List.getRowText(%i);
		%list = getField(%list,0);
		if(%name $= %list)
		{
			echo(%name SPC"is in the list");
			return 1;
			break;
		}
	}
	return 0;
}
function isNotifyOnline(%name)
{
	for(%i=0;%i<=RTBIC_UserList.rowCount();%i++)
	{
		%line = RTBIC_UserList.getRowText(%i);
		%IRCName = getField(%line,1);
		if(%name $= %IRCName)
		{
			return 1;
			break;
		}
	}
	return 0;
}
function checkNotifyPart(%name)
{
	for(%i=0;%i<=RTBIC_UserList.rowCount();%i++)
	{
		%line = RTBIC_UserList.getRowText(%i);
		%IRCName = getField(%line,1);
		%nameLength = getSubStr(%IRCName,0,strLen(%name));
		if(%name $= %nameLength)
		{
			return %IRCName;
			break;
		}
	}
	return "";
}
function onlineStatus(%name)
{
	if(isNotifyOnline(%name) == 1)
	{
		%return = "Online";
	}
	else
	{
		%return = "\c3Offline";
	}
	return %return;
}
function findFirstBlankNotify()
{
	for(%i=0;%i<$IRCNotify::Count;%i++)
	{
		%line = $IRCNotify::Notify[%i];
		if(%line $= "")
		{
			return %i;
			break;
		}
	}
	return $IRCNotify::Count;
}
function addOriginalNotify()
{
	for(%i=0;%i<$IRCNotify::Count;%i++)
	{
		%name = $IRCNotify::Notify[%i];
		if(%name !$= "")
		{
			IRCNotify_Add(%name,0,%i);
		}
	}
	IRCNotify_Sort($IRCNotify::Sort);
}
function IRCNotify_Open()
{
	canvas.pushDialog(RTB_notify);
	IRCNotify_List.clear();
	addOriginalNotify();
}
addOriginalNotify();

function IRCNotify_Find(%player)
{
	if(getField(%player,1) $= "Online")
	{
		$IRCNotify::playerCheck = getField(%player,0);
		checkServers();
	}
}